#include <NTDDK.H>

#include "samhook.h"
#include "LOGOUT.h"
#pragma optimize("", off)

extern ULONG LogoCount;
extern PLOGOENTRY LogoData;
extern ProcessNameOffset;
extern BOOLEAN CreateSign;

ULONG	GlControl;

PDRIVER_DISPATCH OldReadDispatch=0;
PDRIVER_DISPATCH OldWriteDispatch=0;
PDRIVER_UNLOAD OldUnload=0;

NTSTATUS
ObOpenObjectByName (
    IN POBJECT_ATTRIBUTES ObjectAttributes,
    IN ULONG  OPTIONAL,
    IN ULONG AccessMode,
    IN ULONG OPTIONAL2,
    IN ULONG DesiredAccess OPTIONAL,
    IN OUT PVOID ParseContext OPTIONAL,
    OUT PHANDLE Handle
    );

void SAMHOOKUnload(PDRIVER_OBJECT DriverObject)
{
	if( OldUnload )
		OldUnload( DriverObject );
	
	OldReadDispatch=0;
	OldWriteDispatch=0;
	OldUnload=0;
}

NTSTATUS SAMHOOKReadDispatch(PDEVICE_OBJECT DeviceObject, PIRP Irp)
{
	unsigned char * ProcessName;
	ULONG ProcessId;

	if( GlControl & fLOCK )
	{
	}
	else
	{
		if( OldReadDispatch )
			return OldReadDispatch( DeviceObject, Irp );
		else
		{
			Irp->IoStatus.Status = STATUS_UNSUCCESSFUL;
			Irp->IoStatus.Information = 0;
			IoCompleteRequest( Irp, IO_NO_INCREMENT );
			return STATUS_UNSUCCESSFUL;
		}
	}

	ProcessName = (unsigned char *)ExAllocatePool( NonPagedPool, PROCESSNAMESIZE );
	ProcessId = (ULONG)PsGetCurrentProcessId();
	GetProcessName( ProcessName );
	cUpper( ProcessName );
	
	InputLogo( "SAMHOOK", ProcessId, ProcessName, "SERIAL ACCESS DENIED", 1, CANNOT );

	Irp->IoStatus.Status = STATUS_ACCESS_DENIED;
	Irp->IoStatus.Information = 0;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );
	ExFreePool( ProcessName );
	return STATUS_ACCESS_DENIED;
}

NTSTATUS SAMHOOKWriteDispatch(PDEVICE_OBJECT DeviceObject, PIRP Irp)
{
	unsigned char * ProcessName;
	ULONG ProcessId;

	if( GlControl & fLOCK )
	{
	}
	else
	{
		if( OldWriteDispatch )
			return OldWriteDispatch( DeviceObject, Irp );
		else
		{
			Irp->IoStatus.Status = STATUS_UNSUCCESSFUL;
			Irp->IoStatus.Information = 0;
			IoCompleteRequest( Irp, IO_NO_INCREMENT );
			return STATUS_UNSUCCESSFUL;
		}
	}

	ProcessName = (unsigned char *)ExAllocatePool( NonPagedPool, PROCESSNAMESIZE );
	ProcessId = (ULONG)PsGetCurrentProcessId();
	GetProcessName( ProcessName );
	cUpper( ProcessName );
	
	InputLogo( "SAMHOOK", ProcessId, ProcessName, "SERIAL ACCESS DENIED", 1, CANNOT );

	Irp->IoStatus.Status = STATUS_ACCESS_DENIED;
	Irp->IoStatus.Information = 0;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );
	ExFreePool( ProcessName );
	return STATUS_ACCESS_DENIED;
}

NTSTATUS SAMHOOKMyDispatch(PDEVICE_OBJECT DeviceObject, PIRP Irp)
{
	PIO_STACK_LOCATION pStack;
	PDEVICE_OBJECT pFBDeviceObject;
	PDEVICE_EXTENSION pDE;
	PLOGOENTRY UserLogoEntry;
	ULONG * pdwLogCount;
	ULONG WantLogoCount;

	pStack = IoGetCurrentIrpStackLocation( Irp );

	if( pStack->MajorFunction == IRP_MJ_CREATE )
	{
		CreateSign = TRUE;
		Irp->IoStatus.Status = STATUS_SUCCESS;
		Irp->IoStatus.Information = 0;
		IoCompleteRequest( Irp, IO_NO_INCREMENT );
		return STATUS_SUCCESS;
	}

	if( pStack->MajorFunction == IRP_MJ_CLOSE )
	{
		Irp->IoStatus.Status = STATUS_SUCCESS;
		Irp->IoStatus.Information = 0;
		IoCompleteRequest( Irp, IO_NO_INCREMENT );
		return STATUS_SUCCESS;
	}

	if( pStack->MajorFunction == IRP_MJ_DEVICE_CONTROL )
	{
		switch( pStack->Parameters.DeviceIoControl.IoControlCode )
		{
		case IOCTL_BLOCK:
			GlControl |= fLOCK;
			break;
		case IOCTL_NOBLOCK:
			GlControl &= ~fLOCK;
			break;
		case IOCTL_LOGO_COUNT:
			pdwLogCount = Irp->AssociatedIrp.SystemBuffer;
			*pdwLogCount = LogoCount;
			Irp->IoStatus.Status = STATUS_SUCCESS;
			Irp->IoStatus.Information = sizeof(ULONG);
			IoCompleteRequest( Irp, IO_NO_INCREMENT );
			return STATUS_SUCCESS;
		case IOCTL_LOGO_DATA:
			UserLogoEntry = Irp->AssociatedIrp.SystemBuffer;
			WantLogoCount = pStack->Parameters.DeviceIoControl.OutputBufferLength / sizeof(LOGOENTRY);
			WantLogoCount = (WantLogoCount<LogoCount)? WantLogoCount:LogoCount;
			memcpy( (char *)UserLogoEntry, (char *)LogoData, WantLogoCount * sizeof(LOGOENTRY) );
			memcpy( (char *)LogoData, (char *)(LogoData + WantLogoCount), (LogoCount - WantLogoCount) * sizeof(LOGOENTRY) );
			LogoCount -= WantLogoCount;
			Irp->IoStatus.Status = STATUS_SUCCESS;
			Irp->IoStatus.Information = WantLogoCount * sizeof(LOGOENTRY);
			IoCompleteRequest( Irp, IO_NO_INCREMENT );
			return STATUS_SUCCESS;
		}
	}

	Irp->IoStatus.Status = STATUS_SUCCESS;
	Irp->IoStatus.Information = 0;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );
	return STATUS_SUCCESS;
}

PDRIVER_OBJECT SearchDriverObject( PUNICODE_STRING pUni )
{
	NTSTATUS st;
	HANDLE Handle;
	UNICODE_STRING Uni;
	OBJECT_ATTRIBUTES ObjectAttributes;
	PDRIVER_OBJECT Object;

       InitializeObjectAttributes( &ObjectAttributes,
	                                pUni,
	                                OBJ_CASE_INSENSITIVE,
	                                NULL,
	                                NULL );

    	st = ObOpenObjectByName( &ObjectAttributes,
                                 0L,
                                 0L,
                                 0L,
                                 0L,
                                 0L,
                                 &Handle );
	if( st != STATUS_SUCCESS )
		return (PDRIVER_OBJECT)0;

    	st = ObReferenceObjectByHandle( Handle,
                                        0x80000000,
                                        NULL,
                                        0,
                                        &Object,
                                        NULL );
	if( st != STATUS_SUCCESS )
	{
		ZwClose( Handle );
		return (PDRIVER_OBJECT)0;
	}
		
	ZwClose( Handle );
	ObDereferenceObject( Object );
	return Object;	
}

BOOLEAN HookSerialDriver()
{			
	UNICODE_STRING Uni;
	PDRIVER_OBJECT pDriverObjectSerial;
	
	RtlInitUnicodeString( &Uni, L"\\Driver\\Serial" );

	pDriverObjectSerial = SearchDriverObject( &Uni );
	if( pDriverObjectSerial )		
	{
		if( (ULONG)pDriverObjectSerial->MajorFunction[IRP_MJ_READ] != (ULONG)SAMHOOKReadDispatch )
		{
			OldReadDispatch= pDriverObjectSerial->MajorFunction[IRP_MJ_READ];
			pDriverObjectSerial->MajorFunction[IRP_MJ_READ] = SAMHOOKReadDispatch;					
		}
		if( (ULONG)pDriverObjectSerial->MajorFunction[IRP_MJ_WRITE] != (ULONG)SAMHOOKWriteDispatch )
		{
			OldWriteDispatch= pDriverObjectSerial->MajorFunction[IRP_MJ_WRITE];
			pDriverObjectSerial->MajorFunction[IRP_MJ_WRITE] = SAMHOOKWriteDispatch;					
		}
		if( (ULONG)pDriverObjectSerial->DriverUnload != (ULONG)SAMHOOKUnload )
		{
			OldUnload= pDriverObjectSerial->DriverUnload;
			pDriverObjectSerial->DriverUnload= SAMHOOKUnload;					
		}
		return TRUE;
	}
	else
		return FALSE;
}

NTSTATUS DriverEntry(PDRIVER_OBJECT DriverObject, PUNICODE_STRING RegistryPath)
{
    	PDEVICE_EXTENSION devExt;
    	PDEVICE_OBJECT  functionalDeviceObject;
    	NTSTATUS code = STATUS_SUCCESS;     
    	UNICODE_STRING UniDeviceName;
    	UNICODE_STRING UniDosDeviceName;
	unsigned char i;
	BOOLEAN bRet;

	// Hook Serial.SYS
	bRet = HookSerialDriver();
	if( bRet == FALSE )
		return STATUS_UNSUCCESSFUL;

	GlControl = 0;
	
	LogoData = (LOGOENTRY *)ExAllocatePool( NonPagedPool, sizeof(LOGOENTRY)*MAXLOGOENTRY );
	ProcessNameOffset = GetProcessNameOffset();
	CreateSign = FALSE;

	DriverObject->MajorFunction[IRP_MJ_CREATE] = SAMHOOKMyDispatch;
	DriverObject->MajorFunction[IRP_MJ_CLOSE] = SAMHOOKMyDispatch;
	DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = SAMHOOKMyDispatch;
	
	RtlInitUnicodeString( &UniDeviceName, L"\\Device\\SAMHOOK" );

       IoCreateDevice(DriverObject,sizeof(DEVICE_EXTENSION),
                          &UniDeviceName,FILE_DEVICE_UNKNOWN,0,FALSE,&functionalDeviceObject);
       
       functionalDeviceObject->Flags &= ~DO_DEVICE_INITIALIZING;
       devExt = (PDEVICE_EXTENSION)functionalDeviceObject->DeviceExtension;
       RtlZeroMemory(devExt, sizeof(DEVICE_EXTENSION));
	devExt->dwType = FORAPP;
	functionalDeviceObject->Flags |= DO_BUFFERED_IO;
	RtlInitUnicodeString( &UniDosDeviceName, L"\\DosDevices\\SAMHOOK" );
	IoCreateSymbolicLink( &UniDosDeviceName, &UniDeviceName );

       return(STATUS_SUCCESS); 
}
