#include <ntddk.h>        /* required for WDM driver development */
#include <stdarg.h>     /* standard io include files */
#include <stdio.h>

#include "devioctl.h"
#include <initguid.h>

DEFINE_GUID(GUID_SAMPLE, 
0x5665dec0, 0xa40a, 0x11d1, 0xb9, 0x84, 0x0, 0x20, 0xaf, 0xd7, 0x97, 0x78);
//  츮  DeviceStack  Interface GUID մϴ

// α׷ ְ ControlCode մϴ
#define IOCTL_SAMPLE_SET_FREQUENCY	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x0800, METHOD_BUFFERED, FILE_ANY_ACCESS)

#pragma optimize("", off)
#include "STARTIO.h"    

NTSTATUS                                                            
DriverEntry                                                         
	(                                                               
	IN PDRIVER_OBJECT DriverObject,             /* pointer to the device object */
	IN PUNICODE_STRING RegistryPath             /* pointer to a unicode string representing the path */
												/*    to the drivers specific key in the registry    */
	)// ̹ ޸𸮿 óϴ 쿡 ѹ ȣ˴ϴ
{
	NTSTATUS returnStatus = STATUS_SUCCESS;     /* stores status to be returned */

	DbgPrint("DriverEntry ++ \n" );

	DriverObject->DriverUnload = STARTIO_Unload;
	DriverObject->DriverExtension->AddDevice = STARTIO_AddDevice;
	DriverObject->MajorFunction[IRP_MJ_PNP] = STARTIO_PnpDispatch;
	DriverObject->MajorFunction[IRP_MJ_POWER] = STARTIO_PowerDispatch;
	DriverObject->MajorFunction[IRP_MJ_CREATE] = STARTIO_Create;
	DriverObject->MajorFunction[IRP_MJ_CLOSE] = STARTIO_Close;
	DriverObject->MajorFunction[IRP_MJ_CLEANUP] = STARTIO_Cleanup;
	// Win32 API CloseHandle();
	DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = STARTIO_DeviceIoControl;
	// Win32 API DeviceIoControl();
	DriverObject->DriverStartIo = STARTIO_StartIo; // <<<--- StartIo()Լ ϰ ֽϴ

	DbgPrint("DriverEntry -- \n" );
	return returnStatus;
}

NTSTATUS
STARTIO_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	)// PNPManager ̰ ؼ IRP DeviceStack ϶ û մϴ
{
	/* IRP DeviceStack ϱ ؼ  ܰ踦 ġ ˴ϴ 
	1. DeviceObject۾
	2. ϴ DeviceStack DeviceObject ø
	3. DeviceObject Flag ϱ
	*/
	PDEVICE_EXTENSION deviceExtension;              
	NTSTATUS returnStatus = STATUS_SUCCESS;         
	PDEVICE_OBJECT DeviceObject = NULL;             
	ULONG dwRet;

	DbgPrint("STARTIO_AddDevice ++ \n" );

	returnStatus = IoCreateDevice                                       
					(                                               
						DriverObject,                               
						sizeof ( DEVICE_EXTENSION ),                
						NULL,                   
						FILE_DEVICE_UNKNOWN,
						FILE_AUTOGENERATED_DEVICE_NAME,                                          
						FALSE,                                      
						&DeviceObject       
					);// DeviceObject մϴ

	if( !NT_SUCCESS( returnStatus ) )
	{
		DbgPrint("IoCreateDevice() Error, Status = %8X\n", returnStatus );
		goto STARTIO_AddDevice_Exit;
	}

	deviceExtension = DeviceObject->DeviceExtension;

	RtlZeroMemory( deviceExtension, sizeof(DEVICE_EXTENSION));

	deviceExtension->PhysicalDeviceObject = PhysicalDeviceObject;
	
	deviceExtension->DeviceObject = DeviceObject;

	deviceExtension->NextLayerDeviceObject =
	IoAttachDeviceToDeviceStack (
							DeviceObject,
							PhysicalDeviceObject	
	);// ϴ DeviceStack DeviceObject øϴ

	DeviceObject->Flags |= deviceExtension->NextLayerDeviceObject->Flags & 
							( DO_POWER_PAGABLE  | DO_POWER_INRUSH); // DeviceObject Flag մϴ

	DeviceObject->Flags &= ~DO_DEVICE_INITIALIZING; // DeviceObject Flag մϴ

	// Timer DPC غմϴ
	KeInitializeTimer( &deviceExtension->MyTimer );
	KeInitializeDpc( &deviceExtension->MyDpc, MyDpcRoutine, DeviceObject );
	
	IoRegisterDeviceInterface( PhysicalDeviceObject, &GUID_SAMPLE, NULL, &deviceExtension->UnicodeString );
	//  츮  DeviceStack  InterfaceGuid մϴ
	// ϵǴ de->UnicodeString ڰ ϴ ̸Դϴ


STARTIO_AddDevice_Exit:
	DbgPrint("STARTIO_AddDevice -- \n" );
	return returnStatus;
}

VOID                                                                
STARTIO_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	)
{// ̻ ̹  DeviceObject  ̰ ȣ, ̹ ޸𸮿 ŵ˴ϴ

	DbgPrint("STARTIO_Unload ++ \n" );

	// Do job..

	DbgPrint("STARTIO_Unload -- \n" );
}

NTSTATUS
STARTIO_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	)// ɾ IRP NextLayer ̹ IoCompleteRequest()Լ ؼ ûǴ 쿡 ȣ˴ϴ
{
	PKEVENT event = Context;    /* kernel event passed in Context */

	DbgPrint("STARTIO_DeferIrpCompletion ++ \n" );

	KeSetEvent(event,
			   1,
			   FALSE);

	
	DbgPrint("STARTIO_DeferIrpCompletion -- \n" );

	return STATUS_MORE_PROCESSING_REQUIRED; // IoCompleteRequest()Լ Ͽ,  IRP  ߴ϶ û մϴ
}

NTSTATUS
STARTIO_PnpDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	)
{// PNPManager  IRP óϴ ó
	PIO_STACK_LOCATION pStack;                /* pointer to IRP stack */
	PDEVICE_EXTENSION deviceExtension;          /* pointer to device extention */
	NTSTATUS returnStatus = STATUS_SUCCESS;     /* stores status to be returned */
	PDEVICE_OBJECT NextLayerDeviceObject;           /* pointer to the stack device object */
	
	DbgPrint("STARTIO_PnpDispatch ++ \n" );

	pStack = IoGetCurrentIrpStackLocation ( Irp );
	deviceExtension = DeviceObject->DeviceExtension;
	NextLayerDeviceObject = deviceExtension->NextLayerDeviceObject;
			
	switch ( pStack->MinorFunction )
	{
		case IRP_MN_START_DEVICE :
		{// DeviceStack ϶ 㰡 ǹմϴ
			KEVENT event;   /* event used to wait for an operation to complete */
			KeInitializeEvent(&event, NotificationEvent, FALSE);
			IoCopyCurrentIrpStackLocationToNext(Irp);  
			IoSetCompletionRoutine(Irp,
								   STARTIO_DeferIrpCompletion,
								   &event,
								   TRUE,
								   TRUE,
								   TRUE); // STARTIO_DeferIrpCompletion()Լ  IRP  Next Layer Driver ȣϴ
										  // IoCompleteRequest()Լ ؼ ȣǵ մϴ
			
			returnStatus = IoCallDriver(NextLayerDeviceObject,Irp); // NextLayer Driver   ѵ,  Ȯմϴ
			if (returnStatus == STATUS_PENDING) 
			{
				KeWaitForSingleObject(
					&event,
					Executive,
					KernelMode,
					FALSE,
					NULL);
				returnStatus = Irp->IoStatus.Status;
			}
			if( !NT_SUCCESS( returnStatus ) )
			{
				DbgPrint("Start Device Fail\n" );
				IoCompleteRequest( Irp, IO_NO_INCREMENT );
				goto STARTIO_PnpDispatch_Exit;
			}
			// NextLayer Driver    ٷ, 츮 ΰ ص ٴ ǹԴϴ

			// Do Job...
			IoSetDeviceInterfaceState( &deviceExtension->UnicodeString, TRUE ); 
			// ڰ 츮 DeviceStack ϴ  

			IoCompleteRequest( Irp, IO_NO_INCREMENT ); //  IRP ûմϴ
			// STARTIO_DeferIrpCompletion()Լ 츮 IRP  Next Layer Driver ȣ IoCompleteRequest() 
		}	// ϵ "STATUS_MORE_PROCESSING_REQUIRED" ױ⶧, 츮 û ؾմϴ
		break;

		case IRP_MN_SURPRISE_REMOVAL :
		{ // ڱ ġ PC ŵǾٴ ǹ̿ ޵˴ϴ

			IoSetDeviceInterfaceState( &deviceExtension->UnicodeString, FALSE );
			// ڰ 츮 DeviceStack ϴ  

			Irp->IoStatus.Status = STATUS_SUCCESS;
			IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
		}
		break;

		case IRP_MN_REMOVE_DEVICE :
		{ // IRP DeviceStack ü϶ û ǹ̷ ޵˴ϴ
			IoSetDeviceInterfaceState( &deviceExtension->UnicodeString, FALSE );
			// ڰ 츮 DeviceStack ϴ  

			RtlFreeUnicodeString( &deviceExtension->UnicodeString );
			// ڰ ϴ ̸ ޸𸮿 Ѵ

			IoDetachDevice ( NextLayerDeviceObject );// Next Layer Driver  켱 ϴ
													 // STARTIO_AddDevice() IoAttachDeviceToDeviceStack()Լ ݴǹ
			IoDeleteDevice ( DeviceObject );		 // 츮 DeviceObject մϴ
													 // STARTIO_AddDevice() IoCreateDevice()Լ ݴǹ
			Irp->IoStatus.Status = STATUS_SUCCESS;
			IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
		}
		break;

		default:
		{
			IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
			returnStatus = IoCallDriver(NextLayerDeviceObject, Irp);
		}
		break;
	} 

STARTIO_PnpDispatch_Exit:
	DbgPrint("STARTIO_PnpDispatch -- \n" );

	return returnStatus;
}

NTSTATUS                                                            
STARTIO_PowerDispatch
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{// POWERManager  IRP óϴ ó
	PDEVICE_EXTENSION		deviceExtension;
	NTSTATUS returnStatus;
	PDEVICE_OBJECT NextLayerDeviceObject;           /* pointer to the stack device object */
	
	DbgPrint("STARTIO_PowerDispatch ++ \n" );

	deviceExtension = DeviceObject->DeviceExtension;
	NextLayerDeviceObject = deviceExtension->NextLayerDeviceObject;

	PoStartNextPowerIrp( Irp ); //  ٸ Power IRP   ִٰ PowerManager ˸ϴ
	IoSkipCurrentIrpStackLocation( Irp ); //  IRP  ɶ ̻   ʰڴٴ ǹԴϴ
	returnStatus = PoCallDriver(NextLayerDeviceObject, Irp); // Power IRP ٸ IRP ޸, ݵ PoCallDriver()Լ ؾ մϴ
	
	DbgPrint("STARTIO_PowerDispatch -- \n" );
	return returnStatus;
} 

NTSTATUS                                                            
STARTIO_Create
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{// Application  CreateFile()Լ Ǵ ó
	NTSTATUS returnStatus = STATUS_SUCCESS;
	PIO_STACK_LOCATION pStack;

	DbgPrint("STARTIO_Create ++ \n" );

	DbgPrint("STARTIO_Create -- \n" );

	Irp->IoStatus.Status = returnStatus;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );

	return returnStatus;
} 

NTSTATUS                                                            
STARTIO_Close
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{// Application  CloseHandle()Լ Ǵ ó
	NTSTATUS returnStatus = STATUS_SUCCESS;
	PIO_STACK_LOCATION pStack;

	DbgPrint("STARTIO_Close ++ \n" );

	DbgPrint("STARTIO_Close -- \n" );

	Irp->IoStatus.Status = returnStatus;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );

	return returnStatus;
} 

NTSTATUS                                                            
STARTIO_Cleanup
	(                                                               
		IN PDEVICE_OBJECT DeviceObject,                             
		IN PIRP Irp                                                 
	)
{// Application  CloseHandle()Լ Ǵ ó
	NTSTATUS returnStatus = STATUS_SUCCESS;
	PIO_STACK_LOCATION pStack;

	DbgPrint("STARTIO_Cleanup ++ \n" );

	DbgPrint("STARTIO_Cleanup -- \n" );

	Irp->IoStatus.Status = returnStatus;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );

	return returnStatus;
} 

NTSTATUS
STARTIO_DeviceIoControl
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	)
{ // α׷ ȣϴ Win32 API DeviceIoControl()Լ Ǵ Լ
	NTSTATUS returnStatus = STATUS_SUCCESS;
	PIO_STACK_LOCATION pStack;
	ULONG dwRequestSize=0;

	DbgPrint("STARTIO_DeviceIoControl ++ \n" );

	pStack = IoGetCurrentIrpStackLocation( Irp );

	switch( pStack->Parameters.DeviceIoControl.IoControlCode )
	// α׷ ϴ ControlCode Ȯմϴ. 
	// ̰ Ķ ȿ Ȯմϴ.
	{
		case IOCTL_SAMPLE_SET_FREQUENCY:
			returnStatus = STATUS_PENDING;
			break;
		default:
			returnStatus = STATUS_INVALID_PARAMETER;
			break;
	}

	if( returnStatus == STATUS_PENDING )
	{
		IoMarkIrpPending( Irp ); // Irp 񵿱 Ұ ŷ
		IoStartPacket( DeviceObject, Irp, NULL, NULL ); 
		// Irp IO Manager ñ
		// STARTIO_StartIo()Լ IO Manager ؼ Ǿ 䱸
	}
	else
	{
		Irp->IoStatus.Information = 0;
		Irp->IoStatus.Status = returnStatus;
		IoCompleteRequest( Irp, IO_NO_INCREMENT );
	}

	DbgPrint("STARTIO_DeviceIoControl -- \n" );

	return returnStatus;
}

void 
_SpeakerOn( unsigned short Frequency )
{
	unsigned short TimerValue;
	unsigned char TimerValueHighByte;
	unsigned char TimerValueLowByte;

	TimerValue = 1193180 / Frequency;
	TimerValueHighByte = TimerValue / 0x100;
	TimerValueLowByte = TimerValue % 0x100;

	WRITE_PORT_UCHAR( (PUCHAR)0x61, 0x00 );
	WRITE_PORT_UCHAR( (PUCHAR)0x43, 0xB6 );
	WRITE_PORT_UCHAR( (PUCHAR)0x42, TimerValueLowByte );
	WRITE_PORT_UCHAR( (PUCHAR)0x42, TimerValueHighByte );
	WRITE_PORT_UCHAR( (PUCHAR)0x61, 0x03 );
}

void 
_SpeakerOff()
{
	WRITE_PORT_UCHAR( (PUCHAR)0x61, 0x00 );
}

void
STARTIO_StartIo
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	)
{
	NTSTATUS returnStatus = STATUS_SUCCESS;
	PIO_STACK_LOCATION pStack;
	ULONG dwRequestSize=0;
	PVOID pBuffer;
	PDEVICE_EXTENSION deviceExtension;

	DbgPrint("STARTIO_StartIo ++ \n" );

	deviceExtension = (PDEVICE_EXTENSION)DeviceObject->DeviceExtension;

	pStack = IoGetCurrentIrpStackLocation( Irp );

	switch( pStack->Parameters.DeviceIoControl.IoControlCode )
	// α׷ ϴ ControlCode Ȯմϴ. 
	// ̰ Ķ ȿ Ȯմϴ.
	{
		case IOCTL_SAMPLE_SET_FREQUENCY:
			// Ŀ Ѱ ļ մϴ
			// ļ α׷ ݴϴ
			pBuffer = Irp->AssociatedIrp.SystemBuffer;
			_SpeakerOn( *(unsigned short *)pBuffer );

			// Timer  ϴ ϵ̹Ƿ, Ÿ̸(2) ŵϴ
#define TIME_2S 20000000 //  100ns

			KeSetTimer( &deviceExtension->MyTimer, 
				RtlConvertLongToLargeInteger( 20000000 * -1 ), 
				&deviceExtension->MyDpc );

			break;
	}

	DbgPrint("STARTIO_StartIo -- \n" );
}

VOID
MyDpcRoutine(
    IN PKDPC Dpc,
    IN PVOID DeferredContext,
    IN PVOID SystemArgument1,
    IN PVOID SystemArgument2
    )
{
	PDEVICE_OBJECT DeviceObject;

	DbgPrint("MyDpcRoutine ++ \n" );

	DeviceObject = (PDEVICE_OBJECT)DeferredContext;

	_SpeakerOff(); // Speaker ϴ
	
	DeviceObject->CurrentIrp->IoStatus.Status = STATUS_SUCCESS;
	IoCompleteRequest( DeviceObject->CurrentIrp, IO_NO_INCREMENT );
	// DeviceObject->CurrentIrp  STARTIO_StartIo()Լ ؼ óǰ ִ ֱ IRP Ÿ

	IoStartNextPacket( DeviceObject, FALSE );
	//   IRP STARTIO_StartIo()   IO Manager ϴ

	DbgPrint("MyDpcRoutine -- \n" );
}
